{main unit. My number is 10}
{Please read Description.txt!!!!!}

unit serverunit_10;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Spin, ScktComp, extctrls;

type
  Total  = array of cardinal; {contain all results}
  ResultsArray = array[-1..200] of cardinal; {contain data from client}
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Edit2: TEdit;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    ServerSocket1: TServerSocket;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Button1: TButton;
    procedure ServerSocket1ClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure SpinEdit2Exit(Sender: TObject);
    procedure SpinEdit1Exit(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
    Executing : TList; {list of now executing processes}
    LastReady : cardinal;  {Before this cluster all clusters are done}
    MaxCluster : cardinal; {Last cluster}
    CountPrimeNumbers : longint;
    TotalPrime : Total;
  public
    procedure TimeOut(Sender: TObject);
    { Public declarations }
  end;
PTask = ^TTask;
TTask = object
 TimeOut : TTimer;
 Cluster : cardinal;
 procedure Init(ClusterNo : cardinal);
 procedure Done;
end;


var
  Form1: TForm1;

implementation

{$R *.DFM}
 procedure TTask.Init(ClusterNo : cardinal);
 begin
   TimeOut:=TTimer.Create(nil);
   TimeOut.Interval:=500;
   TimeOut.Enabled:=True;
   TimeOut.OnTimer:=Form1.TimeOut;
   Cluster:=ClusterNo;
   TimeOut.Tag:=Cluster;
 end;
 procedure TTask.Done;
 begin
  TimeOut.Free;
 end;


procedure TForm1.TimeOut(Sender: TObject);
var j  : cardinal;
    found : boolean;
begin
{When is timeout  - client is dead, it erase it task from a list}

{      j:=0;
      found:=false;
      if Executing.Count > 0 then
       repeat
         found:= PTask(Executing.Items[j])^.Cluster = TTimer(Sender).Tag;
         inc(j);
       until (found) or (j = Executing.Count-1);
      If Found then Executing.Delete(j);}
end;

procedure TForm1.ServerSocket1ClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   Memo1.Lines.Add('Client connected');
   Label3.Caption:='Total connected: '+Inttostr(ServerSocket1.Socket.ActiveConnections);
end;

procedure TForm1.ServerSocket1ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var i, j  : cardinal;
    found : boolean;
    ResultFromClient : ResultsArray;
    s : string;
    Task : PTask;
begin

  s:=Socket.ReceiveText;
  {finding a cluster number.
   it > LastReady and  not in active task list, named EXECUTING}
  if S= 'I want a task!' then
   begin
    i:=LastReady-1;
    repeat
      inc(i);
      j:=0;
      found:=false;
      if Executing.Count > 0 then
       repeat
         found:= PTask(Executing.Items[j])^.Cluster = i;
         inc(j);
       until (found) or (j >= Executing.Count-1);
    until (not found) or (i >= MaxCluster);
    Memo1.Lines.Add('Task assigned: ['+IntToStr(i*1000)+','+IntToStr(i*1000+1000)+']');
    New(Task);
    Task^.Init(i);
    Executing.Add(Task);
    if i = MaxCluster then Socket.SendText('Please stop') else
    Socket.SendText('Please get a task: '+IntToStr(i));
   end;

   {Getting results}
   Move(s[1],ResultFromClient,SizeOf(ResultFromClient));
   If ResultFromClient[-1] = 4294967295 then
   begin
     SetLength(TotalPrime,CountPrimeNumbers+ResultFromClient[0]+1);
     For i:=1 to ResultFromClient[0] do
      begin
       TotalPrime[CountPrimeNumbers]:=ResultFromClient[i];
       Inc(CountPrimeNumbers);
       Memo1.Lines.Add(IntToStr(ResultFromClient[i]));
      end;
   end;
end;

procedure TForm1.ServerSocket1ClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   Memo1.Lines.Add('Client disconnected');
   Label3.Caption:='Total connected: '+Inttostr(ServerSocket1.Socket.ActiveConnections);

end;

procedure TForm1.SpinEdit2Exit(Sender: TObject);
begin
  If SpinEdit2.Value < SpinEdit1.Value then SpinEdit2.Value:=SpinEdit1.Value;
end;

procedure TForm1.SpinEdit1Exit(Sender: TObject);
begin
  If SpinEdit1.Value > SpinEdit2.Value then SpinEdit1.Value:=SpinEdit2.Value;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 Memo1.Clear;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Executing:=Tlist.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 Executing.Free;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
 if BitBtn1.Caption = 'Start' then
  begin
    SpinEdit1.Enabled:=False;
    SpinEdit2.Enabled:=False;
    Edit1.Enabled:=False;
    Edit2.Enabled:=False;
    BitBtn1.Caption:='Stop!';
    LastReady:=SpinEdit1.Value div 1000;
    MaxCluster :=SpinEdit2.Value div 1000;
  end else
  begin
    SpinEdit1.Enabled:=True;
    SpinEdit2.Enabled:=True;
    Edit1.Enabled:=True;
    Edit2.Enabled:=True;
    BitBtn1.Caption:='Start';
  end;
end;

end.
